/*
 * TEST board WIZARDino-nanoPWM s lCD 4x20
 * V. Patera 2020
 * www.PWMtech.cz
 */
//-----------------------------------------------------------------------------
#include <LiquidCrystal.h>
LiquidCrystal lcd(12,11,5,4,3,2);

#define in_1  A7
#define in_2  A6
#define in_3  A3

#define out_1_pwm10 10
#define out_2_pwm9  9
#define out_3_pwm6  6

byte status_1, status_2, status_3;
char lcd_buffer[5];
unsigned int voltage;
unsigned char out, value, i;
//------------------------------------------------------------------------------
void setup() {
  
 //set outputs
 pinMode(out_1_pwm10,OUTPUT);
 pinMode(out_2_pwm9,OUTPUT);
 pinMode(out_3_pwm6,OUTPUT);

 //set start pwm signal
 analogWrite(out_1_pwm10,255);
 analogWrite(out_2_pwm9,255);
 analogWrite(out_3_pwm6,255); 

 lcd.begin(20,4);
  
 }

void loop() {

 lcd.clear(); 
 lcd.setCursor(0,0);
 lcd.print("**** WIZARDino ****");
 lcd.setCursor(3,1);
 lcd.print("Arduino nanoPWM");
 lcd.setCursor(7,2);
 lcd.write("test");
 lcd.setCursor(3,3);
 lcd.print("www.PWMtech.cz");
 
 delay(3000);
 lcd.clear(); 
 lcd.setCursor(6,0);
 lcd.print("|");
 lcd.setCursor(6,1);
 lcd.print("|");
 lcd.setCursor(6,2);
 lcd.print("|");
 lcd.setCursor(6,3);
 lcd.print("|");
 lcd.setCursor(13,0);
 lcd.print("|");
 lcd.setCursor(13,1);
 lcd.print("|");
 lcd.setCursor(13,2);
 lcd.print("|");
 lcd.setCursor(13,3);
 lcd.print("|");

 lcd.setCursor(1,0);
 lcd.print("=1=");
 
 lcd.setCursor(8,0);
 lcd.print("=2=");
 
 lcd.setCursor(15,0);
 lcd.print("=3=");
  
  while(1){
   //-----------------------------------
   //channel 1 
   //-----------------------------------
   //power %
   voltage=analogRead(0);
   voltage=voltage/5;
   value=voltage;
   if(value>100) value=100;   
   
   lcd.setCursor(0,1);
   sprintf(lcd_buffer,"%3u",value);
   lcd.print(lcd_buffer);  
   lcd.print("[%]"); 

   //activate button
   if(analogRead(in_1)<100){
    while(analogRead(in_1)<100){} 
    
     if(status_1==0){
      lcd.setCursor(0,3);
      lcd.print("START");
       for(i=0;i<value;i++){
        analogWrite(out_1_pwm10,255-((i*255)/100));
        delay(15);
       }
     }   
    status_1=!status_1; 
   }
   
   //set pwm output
   if(status_1){
    analogWrite(out_1_pwm10,255-((value*255)/100));
    lcd.setCursor(0,3);
    lcd.print(" ON  ");
   }
    else{
      analogWrite(out_1_pwm10,255);
      lcd.setCursor(0,3);
      lcd.print(" OFF ");
    }
    
   //-----------------------------------
   //channel 2 
   //-----------------------------------
   //power %
   voltage=analogRead(1);
   voltage=voltage/5;
   value=voltage;
   if(value>100) value=100;   
   
   lcd.setCursor(7,1);
   sprintf(lcd_buffer,"%3u",value);
   lcd.print(lcd_buffer);  
   lcd.print("[%]"); 

   //activate button
   if(analogRead(in_2)<100){
    while(analogRead(in_2)<100){} 
    
     if(status_2==0){
      lcd.setCursor(7,3);
      lcd.print("START");
       for(i=0;i<value;i++){
        analogWrite(out_2_pwm9,255-((i*255)/100));
        delay(15);
       }
     }   
    status_2=!status_2; 
   }
   
   //set pwm output
   if(status_2){
    analogWrite(out_2_pwm9,255-((value*255)/100));
    lcd.setCursor(7,3);
    lcd.print(" ON  ");
   }
    else{
      analogWrite(out_2_pwm9,255);
      lcd.setCursor(7,3);
      lcd.print(" OFF ");
    }
   //-----------------------------------
   //channel 3 
   //-----------------------------------
   //power %
   voltage=analogRead(2);
   voltage=voltage/5;
   value=voltage;
   if(value>100) value=100;   
   
   lcd.setCursor(14,1);
   sprintf(lcd_buffer,"%3u",value);
   lcd.print(lcd_buffer);  
   lcd.print("[%]"); 

   //activate button
   if(analogRead(in_3)<100){
    while(analogRead(in_3)<100){} 
    
     if(status_3==0){
      lcd.setCursor(14,3);
      lcd.print("START");
       for(i=0;i<value;i++){
        analogWrite(out_3_pwm6,255-((i*255)/100));
        delay(15);
       }
     }   
    status_3=!status_3; 
   }
   
   //set pwm output
   if(status_3){
    analogWrite(out_3_pwm6,255-((value*255)/100));
    lcd.setCursor(14,3);
    lcd.print(" ON  ");
   }
    else{
      analogWrite(out_3_pwm6,255);
      lcd.setCursor(14,3);
      lcd.print(" OFF ");
    }
      
  }    
}
